#include "app.h"
#include "drv_adc.h"
#include "drv_uart.h"
#include "hal_systick.h"
#include <arm_math.h>
#include <stdio.h>

uint16_t p_buf[1024] = {0};
uint16_t q_buf[1024] = {0};

void ADCAppTest(void)
{
    SystickInit();
    UARTDrvInit();
    
    ADCDevTypeDef *ptAdcDev = ADCGetDevice();
    if(NULL == ptAdcDev)
    {
        printf("Error. Not found ADC device!\r\n");
        return;
    }
    printf("Success to find ADC device: %s-%d\r\n", ptAdcDev->name, ptAdcDev->channel);
    ptAdcDev->Init(ptAdcDev);
    
    arm_rfft_instance_q15 S = {.fftLenReal = 1024};
    arm_rfft_init_q15(&S, 1024, 0, 0);
    while(1)
    {
        ptAdcDev->Read(ptAdcDev, p_buf, 512);
//        arm_rfft_q15(&S, (q15_t*)p_buf, (q15_t*)q_buf);
        HAL_Delay(1000);
    }
}
